The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Messager Class Reference

STK input control message parser. More...

`#include <Messager.h>`

Inheritance diagram for stk::Messager:

List of all members.

## Public Member Functions
| Messager ()
| Default constructor.
| ~Messager ()
| Class destructor.
void | popMessage (Skini::Message &message)
| Pop the next message from the queue and write it to the referenced message structure.
void | pushMessage (Skini::Message &message)
| Push the referenced message onto the message stack.
bool | setScoreFile (const char *filename)
| Specify a SKINI formatted scorefile from which messages should be read.
bool | startStdInput ()
| Initiate the "realtime" retreival from stdin of control messages into the queue.
bool | startSocketInput (int port=2001)
| Start a socket server, accept connections, and read "realtime" control messages into the message queue.
bool | startMidiInput (int port=0)
| Start MIDI input, with optional device and port identifiers.

## Detailed Description

STK input control message parser.

This class reads and parses control messages from a variety of sources, such as a scorefile, MIDI port, socket connection, or stdin. MIDI messages are retrieved using the RtMidi class. All other input sources (scorefile, socket, or stdin) are assumed to provide SKINI formatted messages. This class can be compiled with generic, non-realtime support, in which case only scorefile reading is possible.

The various realtime message acquisition mechanisms (from MIDI, socket, or stdin) take place asynchronously, filling the message queue. A call to popMessage() will pop the next available control message from the queue and return it via the referenced Message structure. When a non-realtime scorefile is set, it is not possible to start reading realtime input messages (from MIDI, socket, or stdin). Likewise, it is not possible to read from a scorefile when a realtime input mechanism is running.

When MIDI input is started, input is also automatically read from stdin. This allows for program termination via the terminal window. An __SK_Exit_ message is pushed onto the stack whenever an "exit" or "Exit" message is received from stdin or when all socket connections close and no stdin thread is running.

This class is primarily for use in STK example programs but it is generic enough to work in many other contexts.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::Messager::popMessage | ( | Skini::Message & | message | ) |

Pop the next message from the queue and write it to the referenced message structure.

Invalid messages (or an empty queue) are indicated by type values of zero, in which case all other message structure values are undefined. The user MUST verify the returned message type is valid before reading other message values.

bool stk::Messager::setScoreFile | ( | const char * | filename | ) |

Specify a SKINI formatted scorefile from which messages should be read.

A return value of `true` indicates the call was successful. A return value of `false` can occur if the file is not found, cannot be opened, another file is currently still open, or if a realtime input mechanism is running. Scorefile input is considered to be a non-realtime control mechanism that cannot run concurrently with realtime input.

bool stk::Messager::startStdInput | ( |  | ) |

Initiate the "realtime" retreival from stdin of control messages into the queue.

This function initiates a thread for asynchronous retrieval of SKINI formatted messages from stdin. A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, a stdin thread is already running, or a thread error occurs during startup. Stdin input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

bool stk::Messager::startSocketInput | ( | int | port = `2001` | ) |

Start a socket server, accept connections, and read "realtime" control messages into the message queue.

This function creates a socket server on the optional port (default = 2001) and starts a thread for asynchronous retrieval of SKINI formatted messages from socket connections. A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, a socket thread is already running, or an error occurs during the socket server or thread initialization stages. Socket input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

bool stk::Messager::startMidiInput | ( | int | port = `0` | ) |

Start MIDI input, with optional device and port identifiers.

This function creates an RtMidiIn instance for MIDI input. The RtMidiIn class invokes a local callback function to read incoming messages into the queue. If `port` = -1, RtMidiIn will open a virtual port to which other software applications can connect (OS X and Linux only). A return value of `true` indicates the call was successful. A return value of `false` can occur if a scorefile is being read, MIDI input is already running, or an error occurs during RtMidiIn construction. Midi input is considered to be a realtime control mechanism that cannot run concurrently with non-realtime scorefile input.

The documentation for this class was generated from the following file:

- Messager.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.